#!/usr/bin/env python3

import matplotlib.pyplot as plt

from matplotlib import pylab
from mpl_toolkits.mplot3d import Axes3D

from linpy import *

x, y, z = symbols('x y z')

fig = plt.figure(facecolor='white')

diam_plot = fig.add_subplot(2, 2, 1, aspect='equal')
diam_plot.set_title('Diamond')
diam = Ge(y, x - 1) & Le(y, x + 1) & Ge(y, -x - 1) & Le(y, -x + 1)
diam.plot(diam_plot, fill=True, edgecolor='red', facecolor='yellow')

cham_plot = fig.add_subplot(2, 2, 2, projection='3d', aspect='equal')
cham_plot.set_title('Chamfered cube')
cham = Le(0, x) & Le(x, 3) & Le(0, y) & Le(y, 3) & Le(0, z) & Le(z, 3) & \
    Le(z - 2, x) & Le(x, z + 2) & Le(1 - z, x) & Le(x, 5 - z) & \
    Le(z - 2, y) & Le(y, z + 2) & Le(1 - z, y) & Le(y, 5 - z) & \
    Le(y - 2, x) & Le(x, y + 2) & Le(1 - y, x) & Le(x, 5 - y)
cham.plot(cham_plot, facecolors=(1, 0, 0, 0.75))

rhom_plot = fig.add_subplot(2, 2, 3, projection='3d', aspect='equal')
rhom_plot.set_title('Rhombicuboctahedron')
rhom = cham & \
    Le(x + y + z, 7) & Ge(-2, -x - y - z) & \
    Le(-1, x + y - z) & Le(x + y - z, 4) & \
    Le(-1, x - y + z) & Le(x - y + z, 4) & \
    Le(-1, -x + y + z) & Le(-x + y + z, 4)
rhom.plot(rhom_plot, facecolors=(0, 1, 0, 0.75))

cubo_plot = fig.add_subplot(2, 2, 4, projection='3d', aspect='equal')
cubo_plot.set_title('Truncated cuboctahedron')
cubo = Le(0, x) & Le(x, 5) & Le(0, y) & Le(y, 5) & Le(0, z) & Le(z, 5) & \
    Le(x -4, y) & Le(y, x + 4) & Le(-x + 1, y) & Le(y, -x + 9) & \
    Le(y -4, z) & Le(z, y + 4) & Le(-y + 1, z) & Le(z, -y + 9) & \
    Le(z -4, x) & Le(x, z + 4) & Le(-z + 1, x) & Le(x, -z + 9) & \
    Le(3, x + y + z) & Le(x + y + z, 12) & \
    Le(-2, x - y + z) & Le(x - y + z, 7) & \
    Le(-2, -x + y + z) & Le(-x + y + z, 7) & \
    Le(-2, x + y - z) & Le(x + y - z, 7)
cubo.plot(cubo_plot, facecolors=(0, 0, 1, 0.75))

pylab.show()
